using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Kav
{
    public struct GBufferInstanceVertex : IVertexType
    {
        VertexDeclaration IVertexType.VertexDeclaration
        {
            get
            {
                return VertexDeclarations.GBufferInstanceDeclaration;
            }
        }

        public Matrix World { get; set; }
        public Matrix WorldInverseTranspose { get; set; }
        public Matrix WorldViewProjection { get; set; }

        public static readonly VertexDeclaration VertexDeclaration;

        public GBufferInstanceVertex(
            Matrix world,
            Matrix worldInverseTranspose,
            Matrix worldViewProjection
        ) {
            World = world;
            WorldInverseTranspose = worldInverseTranspose;
            WorldViewProjection = worldViewProjection;
        }
    }
}
